// Copyright 2012 The Go Authors.  All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package bench

import "testing"

var x int

func BenchmarkAdd(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v += 1
	}
	x += v
}

func BenchmarkSub(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v -= 1
	}
	x += v
}

func BenchmarkLSL(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v <<= 1
	}
	x += v
}

func BenchmarkLSR(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v >>= 1
	}
	x += v
}

func BenchmarkOR(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v |= 1
	}
	x += v
}

func BenchmarkXOR(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v ^= 1
	}
	x += v
}

func BenchmarkAND(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v &= 1
	}
	x += v
}

func BenchmarkANDNOT(b *testing.B) {
	v := 0
	for i := 0; i < b.N; i++ {
		v &^= 1
	}
	x += v
}
